﻿# -*- coding:Utf-8 -*- 


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es

import os
import re

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


informations = es.AddonInfo()
informations["name"] = "Parachute by L'In20Cible"
informations["version"] = "1.0"
informations["date"] = "2010-05-06"
informations["author"] = "L\'in20Cible"
informations["url"] = "http://addons.eventscripts.com/addons/view/parachute/"
informations["basename"] = "parachute"

es.ServerVar("pc_version", (informations["version"] + " by " + informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


options = {
   "enable": ("1", "pc_enable <1/0> -- Active/Désactive le parachute."),
   "admins": ("0", "pc_admins <1/0> -- Active/Désactive la restriction du parachute aux joueurs qui ne sont pas administrateurs."),
   }
for option in options:
   options[option] = es.ServerVar(("pc_" + option), options[option][0], options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   Initialization()
   es.addons.registerTickListener(TickListenerCallBack)
   
   
def Initialization():
   global players, admins
   players = list()
   filepath = GetConfigurationFilePath("configuration.cfg")
   if os.path.isfile(filepath):
      es.mexec(filepath.replace(es.getString("eventscripts_gamedir").replace(os.sep, "/"), ".."))
   admins = GetConfigurationFileParsed(GetConfigurationFilePath("admins.txt"))
   
   
def unload():
   es.addons.unregisterTickListener(TickListenerCallBack)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetConfigurationFilePath(filename):
   return os.path.join(es.getAddonPath(informations["basename"]), "configuration", filename).replace(os.sep, "/")
   
   
def GetConfigurationFileParsed(filepath):
   returnvalue = list()
   if not os.path.isfile(filepath):
      return returnvalue
   regex = re.compile("//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\n)+")
   for fileline in open(filepath):
      fileline = regex.sub("", fileline).strip()
      if not fileline:
         continue
      returnvalue.append(fileline)
   return returnvalue
   
   
def SetPlayerGravity(userid, value):
   es.server.queuecmd("es_xfire %i !self AddOutput \"gravity %s\"" % (userid, value))
   
   
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def TickListenerCallBack():
   for userid in es.getUseridList():
      if es.getplayerprop(userid, "CCSPlayer.pl.deadflag") or (options["admins"] and (es.getplayersteamid(userid) not in admins)):
         continue
      if es.getplayerprop(userid, "CCSPlayer.baseclass.localdata.m_Local.m_flFallVelocity") > 0.0:
         if userid in players:
            continue
         players.append(userid)
         SetPlayerGravity(userid, "0.1")
      else:
         if userid not in players:
            continue
         players.remove(userid)
         SetPlayerGravity(userid, "1.0")
         
         
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   Initialization()
   
   
def player_death(event_var):
   userid = int(event_var["userid"])
   if userid not in players:
      return
   players.remove(userid)
   
   
def player_disconnect(event_var):
   userid = int(event_var["userid"])
   if userid not in players:
      return
   players.remove(userid)